               /*Ŀ
                                                                        
                  drawRoundRect() = draws a rectangle with rounded      
                           corners of radius 'b' with upper right       
                           corner 'x1,y1', lower left corner 'x2,y2',   
                           in specified color 'color'.                  
                                                                        
                 */

#include "gdraws.h"

extern int LINEWIDTH;

void drawRoundRect(int x1, int y1, int x2, int y2, int b, int color)
{
	int a, col,i,j,row,xend,yend,xstart,ystart;
	long a_square, b_square, two_a_square, two_b_square, four_a_square,
             four_b_square,d;

	x1 = ((x1 + 319)*18) >> 4;
	y1 = 174 - ((93*y1) >> 7);		
	x2 = ((x2 + 319)*18) >> 4;
	y2 = 174 - ((93*y2) >> 7);		
	a = (((int)(b * 18)) >> 4) - LINEWIDTH/2;
	b = ((93*b) >> 7) - LINEWIDTH/2;	
	b_square = b*b;
	a_square = a*a;
	row = b;
	col = 0;
        xend = x2-a;
        yend = y2-b;
	xstart = x1+a;
	ystart = y1+b;
	for (j=-LINEWIDTH/2; j<=LINEWIDTH/2; j++)
	{
		for (i=x1+a; i<=xend; i++)
		{
			plot(i,y1+j,color);
			plot(i,y2+j,color);
		}
	}
	for (j=-LINEWIDTH/2; j<=LINEWIDTH/2; j++)
	{
		for (i=y1+b; i<=yend; i++)
		{
			plot(x1+j,i,color);
			plot(x2+j,i,color);
		}
	}
	a -= LINEWIDTH/2;
	b -= LINEWIDTH/2;
	for (i=0; i<LINEWIDTH; i++,a++,b++)
	{
		b_square = b*b;
		a_square = a*a;
		row = b;
		col = 0;
		two_a_square = a_square << 1;
		four_a_square = a_square << 2;
		four_b_square = b_square << 2;
		two_b_square = b_square << 1;
		d = two_a_square * ((row  -1)*(row )) + a_square +
		    two_b_square*(1-a_square);
		while (a_square*(row ) > b_square * (col))
		{
			plot(col+xend,row+yend,color);
			plot(col+xend,ystart-row, color);
			plot(xstart-col,row+yend,color);
			plot(xstart-col,ystart-row,color);
			if (d>= 0)
			{
				row--;
				d -= four_a_square*(row);
			}
			d += two_b_square*(3 + (col << 1));
			col++;
		}
        	
		d = two_b_square * (col + 1)*col + two_a_square*(row *
        	        (row  -2) +1) + (1-two_a_square)*b_square;
		while (row)
		{
			plot(col+xend,row+yend,color);
			plot(col+xend,ystart-row, color);
			plot(xstart-col,row+yend,color);
			plot(xstart-col,ystart-row,color);
			if (d<= 0)
			{
				col++;
				d += four_b_square*col;
			}
			row--;
			d += two_a_square * (3 - (row <<1));
		}       	
	}
}
